ruh70/carro_de_compras/urls.py
from carro_de_compras import carro
from django.urls import path
from . import views


app_name= "carro" # asignacion de un nickname para evitar rutas o colisiones entre links que van hacia la misma direccion
                  # asi cuando colocamos en la dirección de una url carro:;agregar sabemos que nos estamos refiriendo a estas urls

urlpatterns = [

path('agregar/<int:producto_id>/',views.agregar_producto, name='agregar_prod'),
path('eliminar/<int:producto_id>/',views.eliminar_producto, name='eliminar_prod'),
path('restar/<int:producto_id>/',views.restar_producto, name='restar_prod'),
path('limpiar/',views.limpiar_carro, name='limpiar'),

]

ruh70/ruh70/urls.py
from django.contrib import admin
from django.urls import path, include
from ruh70.views import inicio, home
from django.conf import settings  # para poder importar variables de settings.py
from django.conf.urls.static import static # para agregar caminos estaticos del servidor como URLs de la aplicación

urlpatterns = [
    path('admin/', admin.site.urls, name='admin'),
    path('accounts/', include('django.contrib.auth.urls')),
    path('inicio/',inicio, name='resumen'),
    path('', home, name='home'),
    path('', include('principal.urls')),

    path('inversiones/', include('inversiones.urls')),

    path('noticias/', include('noticias.urls')),

    path('contactanos/',include('contactanos.urls')),

    path('tienda/', include('tienda.urls')),

    path('carro_de_compras/', include('carro_de_compras.urls')),

]


# changing the default link of the main website within the admin platform
admin.site.site_url = "/"

# configurando el camino hacia los urls que llevan a los archivos multimedia, fijarse la definicion
# de estas variables en settings.py
urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

ruh70/tienda/urls.py
from django.urls import path
from . import views

urlpatterns = [
path('',views.tienda, name='tienda'),
]

ruh70/tienda/models.py
from django.db import models


# Create your models here.

class CategoriaProducto(models.Model):
      nombre=models.CharField(max_length=50, verbose_name='Categoria producto')
      created=models.DateTimeField(auto_now_add=True)
      updated=models.DateTimeField(auto_now=True)

      class Meta:
            verbose_name='Categoria producto'
            verbose_name_plural='Categorias producto'

      def __str__(self):
            return self.nombre

class Producto(models.Model):
      nombre=models.CharField(max_length=50, verbose_name='Nombre producto', default='producto defecto')
      categorias = models.ForeignKey(CategoriaProducto, on_delete=models.CASCADE)
      image=models.ImageField(upload_to='tienda',null=True,blank=True)
      precio = models.IntegerField(default=0)
      disponibilidad= models.BooleanField(default=True)
      stock = models.IntegerField(default=1, verbose_name="disponible bodega")
      created=models.DateTimeField(auto_now_add=True)
      updated=models.DateTimeField(auto_now=True)

      class Meta:
            verbose_name='Producto'
            verbose_name_plural='Productos'

      def __str__(self):
            return self.nombre

      def increase_stock(self, numero):
            self.stock += numero
            self.save()

      def reduce_stock(self,numero):
            self.stock -= numero
            self.save()
            

ruh70/tienda/views.py
from django.shortcuts import render
from .models import Producto

# Create your views here.

def tienda(request):
    productos = Producto.objects.all()

    return render(request,'tienda.html',{"productos":productos})

ruh70/tienda/templates/carro/widget.html
<table class="table table-hover table-carro"> 
      <thead>
            <p style="text-align:center">CARRO DE COMPRAS</p>

            <tr>
                  <th> Producto </th>
                  <th> Cantidad  </th>
                  <th> Suma </th>
                  
            </tr>
      </thead>
      <tbody>
            {% if request.session.carro.items %} <!-- si en ESTA SESION del request hay elementos en el carro..
                                                      recordar que el carro es un diccionario creado en carro.py--> 
                  {% for key, value in request.session.carro.items %} <!--Zona de impresión de todos los productos del carro-->

                  <tr class="text-center">
                        <td>{{value.nombre}}</td>
                        <td>{{value.cantidad}}</td>
                         <td>
                              <a href="{% url 'carro:agregar_prod' value.producto_id %}" class='btn btn-sm btn-success' >+</a>
                              <a href="{% url 'carro:restar_prod' value.producto_id %}" class='btn btn-sm btn-success'>-</a><br><br>
                              ${{value.precio}}
                         </td>
                  </tr>
                  {% endfor %}
            {% else %}
                  <tr>
                        <th colspan="3">
                              <div class="alert alert-danger text-center">

                                    Sin productos
                              </div>

                        </th>
                  </tr>
            {% endif %}
      </tbody>

      <tfoot>
            <tr>
                  <th colspan="3">
                        <div class="text-center">
                              Total: $  {{importe_total_carro}}
                              
                        {% if request.session.carro.items %}
                              <br>
                              <a href="{% url 'carro:limpiar' %}" class="btn btn-danger" style="margin-top:10px">Eliminar compras</a>
                        {% endif %}

                        </div>
                  </th>
            </tr>

      </tfoot>
</table>